/*
 * ASE1606.asm
 *
 *  Created: 25/07/2016 18.21.27
 *  Author: Roberto Roncella
 *  Compito del 25/07/2016
 *  Realizzare un programma per il microcontrollore AVR XMEGA256A3BU, che 
 *  a) inizializza prima la periferica di I/O nel modo seguente: 
 *     le porte virtuali 0 e 1 assumono rispettivamente il ruolo della porta C 
 *     (con tutti i pin in ingresso con pull-up) 
 *     e D (con tutti i pin in uscita totem-pole). 
 *     Ai pin della porta C sono collegati esternamente pulsanti verso massa.
 *  b) poi legge continuamente lo stato dei pulsanti e pone in uscita sulla porta virtuale 1
 *     un numero binario pari al numero dei pulsanti premuti.
 */ 
.EQU PORTC_PIN_value=0b01011000 //pin in logica inversa (b6=1) con pull-up (b5_3=011)
.EQU PORTD_PIN_value=0b00000000 //configurazione di uscita totem pole normale
.EQU PORTC_DIR_value=0x00 //tutti i pin in ingresso
.EQU PORTD_DIR_value=0xFF //tutti i pin in uscita
.EQU PINMASK_value=0xFF //tutti i pin configurati allo stesso modo
.EQU VPCTRLA_value=0x32 //valore per configuare le porte virtuali su C (VPORT0) e D (VPORT1)

Configure:
 ldi R16,PINMASK_value
 ldi R17,PORTC_PIN_value
 ldi R18,PORTD_PIN_value
 sts PORTCFG_MPCMASK,R16 //predispone la maschera
 sts PORTC_PIN0CTRL,R17 //basta configurare un pin solo
 sts PORTCFG_MPCMASK,R16
 sts PORTD_PIN0CTRL,R18
 ldi R16,PORTC_DIR_value
 ldi R17,PORTD_DIR_value
 sts PORTC_DIR,R16
 sts PORTD_DIR,R17
 ldi R16,VPCTRLA_value
 sts PORTCFG_VPCTRLA,R16 //configura le due porte virtuali

Init:
 clr R18 //serve per accumulare i carry
loop:
 in R16,VPORT0_IN //attenzione in debug: la lettura richiede almeno 2 cicli
 clr R17 //azzera accumulatore
 ldi R19,8 //contatore
count:
 lsr R16
 adc R17,R18
 dec R19
 brne count
 out VPORT1_OUT,R17
 rjmp loop //ripeti per sempre